#

API Docs for: v3.8.1
Show: Inherited Protected Private Deprecated

# DS.Errors Class

Uses

- Ember.Evented

Extends Ember.ArrayProxy
Defined in: `addon/-private/system/model/errors.js:11`
Module: ember-data

Holds validation errors for a given record, organized by attribute names.

Every `DS.Model` has an `errors` property that is an instance of `DS.Errors`. This can be used to display validation error messages returned from the server when a `record.save()` rejects.

For Example, if you had a `User` model that looked like this:

    import DS from 'ember-data';

    export default DS.Model.extend({
      username: DS.attr('string'),
      email: DS.attr('string')
    });

And you attempted to save a record that did not validate on the backend:

    let user = store.createRecord('user', {
      username: 'tomster',
      email: 'invalidEmail'
    });
    user.save();

Your backend would be expected to return an error response that described the problem, so that error messages can be generated on the app.

API responses will be translated into instances of `DS.Errors` differently, depending on the specific combination of adapter and serializer used. You may want to check the documentation or the source code of the libraries that you are using, to know how they expect errors to be communicated.

Errors can be displayed to the user by accessing their property name to get an array of all the error objects for that property. Each error object is a JavaScript object with two keys:

- `message` A string containing the error message from the backend
- `attribute` The name of the property associated with this error message

    <label>Username: {{input value=username}} </label>
    {{#each model.errors.username as |error|}}
      <div class="error">
        {{error.message}}
      </div>
    {{/each}}

    <label>Email: {{input value=email}} </label>
    {{#each model.errors.email as |error|}}
      <div class="error">
        {{error.message}}
      </div>
    {{/each}}

You can also access the special `messages` property on the error object to get an array of all the error strings.

    {{#each model.errors.messages as |message|}}
      <div class="error">
        {{message}}
      </div>
    {{/each}}

- Index
- Methods
- Properties

## Item Index

### Methods

- _add
- _clear
- _findOrCreateMessages
- _registerHandlers
- _remove
- add
- errorsFor
- has
- remove
- remove
- unknownProperty

### Properties

- content
- errorsByAttributeName
- isEmpty
- length
- messages

## Methods

### `_add`

() private

Defined in `addon/-private/system/model/errors.js:233`

Adds error messages to a given attribute without sending event.

### `_clear`

() private

Defined in `addon/-private/system/model/errors.js:377`

Removes all error messages. to the record.

### `_findOrCreateMessages`

() private

Defined in `addon/-private/system/model/errors.js:248`

### `_registerHandlers`

() private

Defined in `addon/-private/system/model/errors.js:86`

Register with target handler

### `_remove`

() private

Defined in `addon/-private/system/model/errors.js:311`

Removes all error messages from the given attribute without sending event.

### `add`

(

- `attribute`
- `messages`

)

Defined in `addon/-private/system/model/errors.js:187`

Manually adds errors to the record. This will triger the `becameInvalid` event/ lifecycle method on the record and transition the record into an `invalid` state.

Example

     let errors = get(user, 'errors');

     // add multiple errors
     errors.add('password', [
       'Must be at least 12 characters',
       'Must contain at least one symbol',
       'Cannot contain your name'
     ]);

     errors.errorsFor('password');
     // =>
     // [
     //   { attribute: 'password', message: 'Must be at least 12 characters' },
     //   { attribute: 'password', message: 'Must contain at least one symbol' },
     //   { attribute: 'password', message: 'Cannot contain your name' },
     // ]

     // add a single error
     errors.add('username', 'This field is required');

     errors.errorsFor('password');
     // =>
     // [
     //   { attribute: 'username', message: 'This field is required' },
     // ]

#### Parameters:

- `attribute` String
  - the property name of an attribute or relationship
- `messages` String | String
  - an error message or array of error messages for the attribute

### `errorsFor`

(

- `attribute`

)
Array

Defined in `addon/-private/system/model/errors.js:106`

Returns errors for a given attribute

    let user = store.createRecord('user', {
      username: 'tomster',
      email: 'invalidEmail'
    });
    user.save().catch(function(){
      user.get('errors').errorsFor('email'); // returns:
      // [{attribute: "email", message: "Doesn't look like a valid email."}]
    });

#### Parameters:

- `attribute` String

#### Returns:

Array:

### `has`

(

- `attribute`

)
Boolean

Defined in `addon/-private/system/model/errors.js:404`

Checks if there are error messages for the given attribute.

    import Route from '@ember/routing/route';

    export default Route.extend({
      actions: {
        save: function(user) {
          if (user.get('errors').has('email')) {
            return alert('Please update your email before attempting to save.');
          }
          user.save();
        }
      }
    });

#### Parameters:

- `attribute` String

#### Returns:

Boolean:

true if there some errors on given attribute

### `remove`

(

- `member`

)

Defined in `addon/-private/system/model/errors.js:273`

Manually removes all errors for a given member from the record. This will transition the record into a `valid` state, and triggers the `becameValid` event and lifecycle method.

Example:

     let errors = get('user', errors);
     errors.add('phone', ['error-1', 'error-2']);

     errors.errorsFor('phone');
     // =>
     // [
     //   { attribute: 'phone', message: 'error-1' },
     //   { attribute: 'phone', message: 'error-2' },
     // ]

     errors.remove('phone');

     errors.errorsFor('phone');
     // => undefined

#### Parameters:

- `member` String
  - the property name of an attribute or relationship

### `remove`

()

Defined in `addon/-private/system/model/errors.js:330`

Manually clears all errors for the record. This will transition the record into a `valid` state, and will trigger the `becameValid` event and lifecycle method.

Example:

    let errors = get('user', errors);
    errors.add('username', ['error-a']);
    errors.add('phone', ['error-1', 'error-2']);

    errors.errorsFor('username');
    // =>
    // [
    //   { attribute: 'username', message: 'error-a' },
    // ]

    errors.errorsFor('phone');
    // =>
    // [
    //   { attribute: 'phone', message: 'error-1' },
    //   { attribute: 'phone', message: 'error-2' },
    // ]

    errors.clear();

    errors.errorsFor('username');
    // => undefined

    errors.errorsFor('phone');
    // => undefined

    errors.get('messages')
    // => []

### `unknownProperty`

() private

Defined in `addon/-private/system/model/errors.js:160`

## Properties

### `content`

Array private

Defined in `addon/-private/system/model/errors.js:151`

### `errorsByAttributeName`

MapWithDefault private

Defined in `addon/-private/system/model/errors.js:97`

### `isEmpty`

Boolean

Defined in `addon/-private/system/model/errors.js:180`

### `length`

Number

Defined in `addon/-private/system/model/errors.js:172`

Total number of errors.

### `messages`

Array

Defined in `addon/-private/system/model/errors.js:134`

An array containing all of the error messages for this record. This is useful for displaying all errors to the user.

    {{#each model.errors.messages as |message|}}
      <div class="error">
        {{message}}
      </div>
    {{/each}}